
#include "globdef.h"
#include "uidef.h"


ROUTINE par_from_keyboard_routine;
int all_threads_started; 

int spurcancel_flag;
int spurinit_flag;
int autospur_point;
double recent_time;
int hand_key;
int kill_all_flag;
char lbutton_state;
char rbutton_state;
char new_lbutton_state;
char new_rbutton_state;
int no_of_netslaves;
int fft1_blknum;
int raw16_blknum;
int raw18_blknum;
int raw24_blknum;
int fft1_blknum;
int timf2_blknum;
int fft2_blknum;
int next_blkptr_16;
int next_blkptr_18;
int next_blkptr_24;
int next_blkptr_fft1;
int next_blkptr_timf2;
int next_blkptr_fft2;
int netsend_ptr_16;
int netsend_ptr_18;
int netsend_ptr_24;
int netsend_ptr_fft1;
int netsend_ptr_timf2;
int netsend_ptr_fft2;
int latest_listsend_time;
int net_no_of_errors;
int rxin_block_counter;

int lir_errcod;


int font_xsep;
int font_ysep;
int font_w;
int font_h;
int font_size;

int mouse_task;
float min_delay_time;
int savefile_repeat_flag;
int os_flag;
int qz;
float tune_yzer;
int usercontrol_mode;
int workload_reset_flag;
int fft2_to_fft1_ratio;
float baseband_bw_hz;
int baseband_bw_fftxpts;
int lir_inkey;
char *vga_font;
int text_width;
int text_height;
int screen_last_xpixel;
int screen_last_col;
int screen_width;
int screen_height;
int screen_totpix;
int uiparm_change_flag;
USERINT_PARM ui;
SSBPROC_PARM txssb;
CWPROC_PARM txcw;
int mouse_flag;
int mouse_hide_flag;
int mouse_x;
int new_mouse_x;
int mouse_xmax;
int mouse_xmin;
int mouse_y;
int new_mouse_y;
int mouse_ymax;
int mouse_ymin;
int mouse_cursize;
int leftpressed;
int rightpressed;
int mouse_lbutton_x;
int mouse_rbutton_x;
int mouse_lbutton_y;
int mouse_rbutton_y;
int mmx_present;
int simd_present;
int rx_audio_in;
int rx_audio_in2;
int rx_audio_out;
int mixer; 
int rx_channels;
int twice_rxchan;
FILE *dmp;
FILE *sndlog;
FILE *wav_file;
int adout_block;
char *rx_da_wrbuf;
char *tx_da_wrbuf;
int rx_da_totbytes;
int tx_da_totbytes;
float total_wttim;
int rx_daout_bytes;
int rx_daout_channels;
int timinfo_flag;
int ampinfo_flag;
float measured_da_speed;
float measured_ad_speed;
int rx_mode;
int use_bfo;
double diskread_time;
double eme_time;
int dasync_counter;
float dasync_sum;
float dasync_avg1;
float dasync_avg2;
float dasync_avg3;
double dasync_time;
double dasync_avgtime;
double daspeed_time;
double da_start_time;
int overrun_count;
int da_start_samps;
int wav_write_flag;
int wav_read_flag;
int wavfile_bytes;
int audio_dump_flag;
int diskread_pause_flag;
int current_graph_minh;
int current_graph_minw;
int calibrate_flag;
double old_passband_center;
int swmmx_fft1;
int swmmx_fft2;
int swfloat;
int sw_onechan;
int memalloc_no;
int memalloc_max;
MEM_INF *memalloc_mem;
int eme_flag;
int timf3_oscilloscope_limit;
int lir_status;
int allow_parport;
float rx_output_blockrate;


DXDATA *dx;
MEM_INF fft1mem[MAX_FFT1_ARRAYS];
MEM_INF fft3mem[MAX_FFT3_ARRAYS];
MEM_INF basebmem[MAX_BASEB_ARRAYS];
MEM_INF hiresmem[MAX_HIRES_ARRAYS];
MEM_INF afcmem[MAX_AFC_ARRAYS];
MEM_INF voicelabmem[MAX_VOICELAB_ARRAYS];
MEM_INF txmem[MAX_TXMEM_ARRAYS];
MEM_INF blankermem[MAX_BLANKER_ARRAYS];
double flowcnt[MAX_FLOWCNT];
double flowtime;
double old_flowtime;
int mailbox[64];

NET_RX_STRUCT net_rxdata_16;
NET_RX_STRUCT net_rxdata_18;
NET_RX_STRUCT net_rxdata_24;
NET_RX_STRUCT net_rxdata_fft1;
NET_RX_STRUCT net_rxdata_timf2;
NET_RX_STRUCT net_rxdata_fft2;

SLAVE_MESSAGE slave_msg;




char savefile_parname[44];  //40chars +  _ag  + ending zero.


NET_FD netfd;

char userint_filename[]="par_userint";
char network_filename[]="par_network";
char *rxpar_filenames[MAX_RX_MODE]={"par_wcw",
                         "par_cw",
                         "par_hsms",
                         "par_ssb",
                         "par_fm",
                         "par_am",
                         "par_qrss",
                         "par_txtest",
                         "par_test",
                         "par_tune"};

char *rxmodes[MAX_RX_MODE]={"Weak signal CW",
                 "Normal CW",
                 "Meteor scatter CW",
                 "SSB",
                 "FM",
                 "AM",
                 "QRSS CW",
                 "TX TEST",
                 "SOUNDCARD TEST MODE",
                 "ANALOG HARDWARE TUNE"};

#define A MAX_MIX1
#define B MAX_FFT1_VERNR
#define C MAX_FFT1_BCKVERNR
#define D 1000
#define E 1000000
#define F 10000
#define G MAX_FFT2_VERNR
#define H 200
#define K 6000
#define M 8000
#define A1 100
#define B5 5000
int genparm[MAX_GENPARM+2];
//                           1 1  1  1 1   1  1 1 1 1  2 2  2 2 2 2 2 2
//    0 1 2  3 4 5 6 7  8  9 0 1  2  3 4   5  6 7 8 9  0 1  2 3 4 5 6 7
int genparm_min[MAX_GENPARM]=
   {  0,0,0, 0,1,0,0,H, 2, 0,0,0, 2, 0,0,  1, 0,0,0,1, 1,1, 5,0  ,H, 0,0};
int genparm_max[MAX_GENPARM]=
   {800,9,B,60,E,1,C,E,99,10,4,G,16, H,2,800,B5,1,E,H,10,A, D,F  ,E, H,9};
int genparm_default[MAX_RX_MODE][MAX_GENPARM]=
// Weak signal CW
   {100,3,0, 4,D,1,0,K, 6, 2,2,0, 8,20,0,150,A1,0,0,5, 4,1,99,500,K, 1,3,
// Normal CW
    100,3,0, 1,D,0,0,K, 6, 2,2,0, 7, 5,0,150,A1,0,0,5, 4,1,20,100,M, 1,3,
// Meteor scatter CW
    100,2,0, 1,D,1,0,K, 6, 2,2,0, 7, 5,1,150,A1,0,0,5, 4,1,20,100,F, 1,3,
// SSB
     83,2,0, 1,D,1,0,K, 6, 2,2,0, 7, 5,1,150,A1,0,0,5, 4,1,10,100,F, 1,3,
// FM
     84,2,0, 1,D,1,0,K, 6, 2,2,0, 7, 5,1,150,A1,0,0,5, 4,1,10,100,F, 1,3,
// AM
     10,2,0,30,D,0,0,K, 6, 0,2,0, 7,15,1,350,40,0,0,5, 4,1,10,500,M,35,3,
// QRSS CW
    100,2,0, 1,D,1,0,K, 6, 2,2,0, 7, 5,1,150,A1,0,0,5, 4,1,10,500,F, 1,3,
// Tx test
     83,2,0, 1,D,1,0,K, 6, 2,2,0, 7, 5,1,150,A1,0,0,5, 4,1,10,500,F, 1,3,
// Soundcard test
     83,2,0, 1,D,1,0,K, 6, 2,2,0, 7, 5,1,150,A1,0,0,5, 4,1,10,500,F, 1,3,
// Analog hardware tune
     85,2,0, 1,D,1,0,K, 6, 2,2,0, 7, 5,1,150,A1,0,0,5, 4,1,10,500,F, 1,3};



char *genparm_text[MAX_GENPARM+2]={"First FFT bandwidth (Hz)",          //0
                      "First FFT window (power of sin)",                //1
                      "First forward FFT version",                      //2  
                      "First FFT storage time (s)",                     //3 
                      "First FFT amplitude",                            //4
                      "Enable second FFT",                              //5
                      "First backward FFT version",                     //6
                      "Sellim maxlevel",                                //7 
                      "First backward FFT att. N",                      //8 
                      "Second FFT bandwidth factor in powers of 2",     //9
                      "Second FFT window (power of sin)",               //10
                      "Second forward FFT version",                     //11
                      "Second forward FFT att. N",                      //12 
                      "Second FFT storage time (s)",                    //13
                      "Enable AFC/SPUR/DECODE (2=auto spur)",           //14
                      "AFC lock range Hz",                              //15
                      "AFC max drift Hz/minute",                        //16
                      "Enable Morse decoding",                          //17
                      "Max no of spurs to cancel",                      //18
                      "Spur timeconstant (0.1sek)",                     //19
                      "First mixer bandwidth reduction in powers of 2", //20
                      "First mixer no of channels",                     //21
                      "Baseband storage time (s)",                      //22 
                      "Output delay margin (ms)",                       //23   
                      "Output sampling speed (Hz)",                     //24
                      "Default output mode",                            //25
                      "Audio expander exponent",                        //26 
                      "A/D speed",                                      //27
                      "Check"}; 

char *ssbprocparm_text[MAX_SSBPROC_PARM]={"Lowest freq",        //1
                                          "Highest freq",       //2           
                                          "Slope",              //3
                                          "Bass",               //4
                                          "Treble",             //5
                                          "Mic gain",           //6
                                          "Mic out gain",       //7
                                          "Mic AGC time",       //8
                                          "Mic F threshold",    //9 
                                          "Mic T threshold",    //10
                                          "RF1 gain",           //11
                                          "Level dB",           //12
                                          "Check"};             //13

char *cwprocparm_text[MAX_CWPROC_PARM]={"Rise time",        //1
                                        "Level dB",         //2
                                        "Hand key",         //3
                                        "Tone key",         //4
                                        "ASCII input",      //5
                                        "Check"};           //6  

char *uiparm_text[MAX_UIPARM]={"vga mode",          //1
                               "Screen width (%)",  //2
                               "Screen height (%)", //3
                               "font scale",        //4
                               "mouse speed",       //5
                               "Rx input mode",     //6
                               "Rx rf channels",    //7
                               "Rx ad channels",    //8
                               "Rx ad speed",       //9
                               "Rx ad device no",   //10
                               "Rx ad mode",        //11
                               "Rx da device no",   //12
                               "Rx min da speed",   //13  
                               "Rx max da speed",   //14
                               "Rx max da channels",//15
                               "Rx max da bytes",   //16
                               "Rx min da channels",//17
                               "Rx min da bytes",   //18
                               "Rx da stop/start",  //19 
                               "parport",           //20
                               "parport read pin",  //21
                               "network flag",      //22
                               "Tx ad speed",       //23
                               "Tx da speed",       //24
                               "Tx ad device no",   //25
                               "Tx da device no",   //26
                               "Tx da channels",    //27
                               "Tx ad channels",    //28
                               "Tx da bytes",       //29
                               "Tx ad bytes",       //30
                               "Tx enable",         //31
                               "Tx pilot tone dB",  //32
                               "Tx pilot tone time",//33 
                               "check"};            //34


char *ag_intpar_text[MAX_AG_INTPAR]={"ytop",               //1
                                     "ybottom",            //2
                                     "xleft",              //3
                                     "xright",             //4
                                     "mode",               //5
                                     "avgnum",             //6
                                     "window",             //7 
                                     "fit points",         //8
                                     "delay",              //9
                                     "check"};             //10

char *ag_floatpar_text[MAX_AG_FLOATPAR]={"min S/N",        //1
                                         "search range",   //2
                                         "lock_range",     //3
                                         "freq range"};    //4    




char *wg_intpar_text[MAX_WG_INTPAR]={"ytop",               //1
                                     "ybottom",            //2
                                     "xleft",              //3
                                     "xright",             //4
                                     "yborder",            //5
                                     "xpoints per pixel",  //6
                                     "pixels per xpoint",  //7
                                     "first xpoint",       //8
                                     "xpoints",            //9
                                     "avg1num",            //10 
                                     "spek avgnum",        //11  
                                     "waterfall avgnum",   //12
                                     "spur_inhibit",       //13 
                                     "check"};             //14               

char *wg_floatpar_text[MAX_WG_FLOATPAR]={"yzero",          //1
                                         "yrange",         //2 
                                         "wat. db zero",   //3
                                         "wat. db gain"};  //4

char *hg_intpar_text[MAX_HG_INTPAR]={"ytop",                //1
                                     "ybottom",             //2
                                     "xleft",               //3
                                     "xright",              //4
                                     "mode (dumb)",         //5
                                     "mode (clever)",       //6
                                     "timf2 display",       //7 
                                     "timf2 display lines", //8
                                     "timf2 display hold",  //9
                                     "spek avgnum",         //10
                                     "limit (dumb)",        //11
                                     "limit (clever)",      //12
                                     "check"};              //13

char *hg_floatpar_text[MAX_HG_FLOATPAR]={"factor (dumb)",          //1
                                         "factor (clever)",        //2
                                         "sellim fft1 S/N",        //3
                                         "sellim fft2 S/N",        //4    
                                         "timf2 display gain wk",  //5 
                                         "timf2 display gain st"}; //6 

char *bg_intpar_text[MAX_BG_INTPAR]={"ytop",                //1
                                     "ybottom",             //2
                                     "xleft",               //3
                                     "xright",              //4
                                     "yborder",             //5
                                     "fft3 avgnum",         //6
                                     "pixels/point",        //7
                                     "coh factor",          //8 
                                     "delay points",        //9
                                     "AGC flag",            //10
                                     "AGC attack",          //11
                                     "AGC release",         //12
                                     "Waterfall avgnum",    //13
                                     "AFC2 range",          //14
                                     "AFC2 delay",          //15
                                     "Mouse wheel step",    //16 
                                     "Oscill ON",           //17
                                     "check"};              //18

char *bg_floatpar_text[MAX_BG_FLOATPAR]={"filter flat",          //1
                                         "filter curved",        //2
                                         "yzero",                //3
                                         "yrange",               //4    
                                         "dB/pixel",             //5 
                                         "yfac pwr",             //6
                                         "yfac log",             //7
                                         "bandwidth",            //8
                                         "first freq",           //9
                                         "BFO freq",             //10
                                         "Output gain",          //11
                                         "Waterfall gain",       //12
                                         "Waterfall zero",       //13
                                         "Oscill gain"};         //14

char *pg_intpar_text[MAX_PG_INTPAR]={"ytop",            //1
                                     "ybottom",         //2
                                     "xleft",           //3
                                     "xright",          //4
                                     "adapt",           //5
                                     "avg",             //6
                                     "check"};          //7

char *pg_floatpar_text[MAX_PG_FLOATPAR]={"angle",     //1
                                         "c1",        //2
                                         "c2",        //3
                                         "c3"};       //4    



char *cg_intpar_text[MAX_CG_INTPAR]={"ytop",             //1
                                     "ybottom",          //2
                                     "xleft",            //3
                                     "xright",           //4
                                     "Meter graph on",   //5
                                     "Oscill on"};       //6

char *cg_floatpar_text[MAX_CG_FLOATPAR];

char *mg_intpar_text[MAX_MG_INTPAR]={"ytop",             //1
                                     "ybottom",          //2
                                     "xleft",            //3
                                     "xright",           //4
                                     "Scale type",       //5
                                     "Avgnum",           //6
                                     "Tracks",           //7
                                     "Check"};           //8     
															
char *mg_floatpar_text[MAX_MG_FLOATPAR]={"ygain",         //1
                                         "yzero",         //2
                                         "Cal dBm",       //3
                                         "Cal S-units"};  //4  
char *eg_intpar_text[MAX_EG_INTPAR]={"ytop",            //1
                                     "ybottom",         //2
                                     "xleft",           //3
                                     "xright",          //4
                                     "minim"};          //5

char *eg_floatpar_text[MAX_EG_FLOATPAR];


char *fg_intpar_text[MAX_FG_INTPAR]={"ytop",            //1
                                     "ybottom",         //2
                                     "xleft",           //3
                                     "xright",          //4
                                     "yborder",         //5
                                     "direction",       //6
                                     "gain",            //7
                                     "gain_inc"};       //8

char *fg_floatpar_text[MAX_FG_FLOATPAR]={"fq inc",      //1
                                          "freq"};      //2

char *tg_intpar_text[MAX_TG_INTPAR]={"ytop",            //1
                                     "ybottom",         //2
                                     "xleft",           //3
                                     "xright",          //4
                                     "ssbproc no",      //5
                                     "direction"};      //6
                                     
char *tg_floatpar_text[MAX_TG_FLOATPAR]={"freq",        //1
                                         "fq inc",      //2
                                         "band fq"};    //3

char *net_intpar_text[MAX_NET_INTPAR]={"send group",       //1
                                       "receive group",    //2
                                       "port",             //3
                                       "send_raw",         //4
                                       "send_fft1",        //5
                                       "send_fft2",        //6
                                       "send_timf2",       //7
                                       "receive_raw",      //8
                                       "receive_fft1",     //9
                                       "ip1",              //10
                                       "ip2",              //11
                                       "ip3",              //12
                                       "ip4",              //13
                                       "check"};           //14

char modes_man_auto[]={'-','A','M'};
char *press_any_key={"Press any key"};
char *press_enter={"Press ENTER"};
char *audiomode_text[4]={"One rx channel (normal audio)",
                         "One rx channel I/Q (direct conversion rx)",
                         "Two rx channels (adaptive polarisation/phasing)",
                         "Two rx channels I/Q"};
char remind_parsave[]="(Do not forget to save with ""W"" on the main menu)";

